*! version 1.0  Anders Alexandersson 26 April 2004
* output.do for the Stata Journal article
version 8.2
set scheme sj

// to get the output type -sjlog type output1.log.tex- and then copy and paste
sjlog using output1, replace
sysuse auto, clear
scatter mpg weight, by(foreign, total)
ellip mpg weight, by(foreign, total)
ellip mpg weight, by(foreign, total legend(off)) ///
	total tlabel(Total as a by-group) plot(scatter mpg weight)
sjlog close, replace

graph export output1.eps, replace

// to get the output include the file -output1.log.tex-
sjlog using output2, replace
* reproduce Galton's confidence ellipse data
range t 0 `=2*_pi' 4000
gen x = 68.25 + 4 * cos(t)
gen y = 68.25 + 3 * cos(t + acos(`=(4/3)/3'))

* extract major axis
ellip y x, c(2) nograph
local m1 = r(m1) 

* create best fit m1 and normal n2 for evr(.03)
ellip y x, c(2) evr(.3) nograph
assert reldif( 1.067779930389807, r(m1)) < 1e-5
assert reldif( -.2809567697067325, r(m2)) < 1e-5
assert reldif( 3.559266434632692, r(n)) < 1e-5
assert reldif( r(m1)/r(n), r(evr)) < 1e-5
assert reldif( r(m1)*r(m2), -r(evr)) < 1e-5
gen m_y = r(amin_y)
qui replace m_y = r(amax_y) in 2/2
gen m_x = r(amin_x)
qui replace m_x = r(amax_x) in 2/2
gen n2_y = r(n2min_y)
qui replace n2_y = r(amax_y) in 2/2
gen n2_x = r(n2min_x)
qui replace n2_x = r(amax_x) in 2/2

* reproduce Galton's confidence ellipse
ellip y x, c(2) legend(off) plot( 	///
	line m_y m_x, clpat(solid) text(70.5 70 "m") || 	///
	line n2_y n2_x, clpat(solid) text(67 70 "n")) 		///
 	ylab(65.25 68.25 71.25) xlab(64.25 68.25 72.25, grid)	///
	ytick(65.25(1)71.25) xtick(64.25(1)72.25)		///
	ytitle("Mid-parents") xtitle("Adult children")	///
	diameter(`m1') dlopts(clpat(dot))
assert reldif( .6759268231824285, r(e2)) < 1e-5	
sjlog close, replace

graph export output2.eps, replace

exit	
